#include "main.h"

// sprawdza, czy podana nieparzysta liczba jest pierwsza
int is_odd_prime(long candidate) {
  long rest, divisor, difference;

  rest = 1;             // inicjalizacja dowolna wartoscia niezerowa
  divisor = 3;          // rozpocznij od najmniejszego nieparzystego dzielnika
  difference = candidate - 9;
  // niezmiennik petli:
  // difference = candidate - divisor^2
  // divisor' = divisor + 2
  // difference' = candidate - (divisor')^2 = difference - 4 * divisor - 4
  // koniec petli gdy:
  //  1) rest == 0, czyli divisor jest dzielnikiem candidate
  //  2) nastepny divisor bedzie za duzy, tzn. divisor^2 > candidate
  // tak sformulowany warunek petli unika przepelnienia arytmetyki
  while (rest != 0 && difference >= 0) {
    rest = candidate % divisor;
    ++divisor;
    difference -= divisor << 2; // odejmij (4 * divisor + 4)
    ++divisor;                  // wez nastepny nieparzysty dzielnik
  }
  return rest != 0;
}

int main(int argc, char *argv[]) {
  long mem, t, p1, p2, q;
  SET  f;

  if (argc < 2){
    fprintf(stderr, "Usage: %s memsize [MB]\n", argv[0]);
    return 1;
  }
  mem = atol(argv[1]) * 1024 * 1024 - READ_INTERVAL * (long)sizeof(POSET);
  mem -= N * N * sizeof(POSET) + (N + 1) * (N + 1) * (long)sizeof(BINOM);
  #if defined(_IA32_)
  mem -= 6 * 64 * 1024;
  #elif defined(_X86_64_)
  mem -= 3 * 64 * 1024;
  #else
  mem -= 1024 * 1024;
  #endif
  #ifdef _USE_POF2_TABLE_
  mem -= N * (long)sizeof(SET);
  #endif
  #ifdef _USE_MIN_ELEMENT_TABLE_
  mem -= (MET_SIZE + 384) * (long)sizeof(MIN_EL_TBL_EL);
  #endif
  #ifdef _USE_CARDINALITY_TABLE_
  mem -= (CAT_SIZE + 384) * (long)sizeof(CARD_TBL_EL);
  #endif
  if (mem <= (long)(100 * sizeof(POSET))) {
    fprintf(stderr, "ERROR: Too few memory for %d elements.\n", N);
    return 1;
  }
  t = mem / (sizeof(POSET) + 7 * (sizeof(INDEX) / 4));
  q = ((t * 3) / 5) | 1;
  p1 = 2 * q + 1;
  while (!is_odd_prime(q) || !is_odd_prime(p1)) {
    q += 2;
    p1 += 4;
  }
  q = ((t * 11) / 40) | 1;
  p2 = 2 * q + 1;
  while (!is_odd_prime(q) || !is_odd_prime(p2)) {
    q += 2;
    p2 += 4;
  }
  f = (SET)(-1) >> (8 * sizeof(SET) - N);
  printf("#elif N == %d\n"
         "  #define FULL_SET   0x%lXU\n"
         "  #define MAX_STACK     %18ld\n"
         "  #define HASH_TBL_SIZE %18ld\n"
         "  #define SORT_TBL_SIZE %18ld\n",
         N, (unsigned long)f, t, p1, p2);
  fprintf(stderr, "%d elements configured successfully.\n", N); 
  return 0;
}
