#!/bin/csh
#PBS -N S15_2
#PBS -l nodes=1:ppn=1,walltime=336:00:00,mem=1960mb
#PBS -j oe
#PBS -k oe
#
# PBS file for the second part of the n=15 experiment
#

#The following variables have to be defined:
#set from=0
#set morf=18000000
#set step=1000

set soft_end=`date +%s`
@ soft_end += 1080000
set c_min=17
set c_max=33
set EXE=./proof15
set WRKDIR=/tmp1/user/S15_$soft_end/
set STEPFILE=15step
set SORTFILE=15sort

mkdir -p $WRKDIR
cd $WRKDIR
if (!(-e $EXE)) then
  cp ~/$EXE .
endif

date
set result=0
set to=0
while (($result <= 1) && ($from <= $morf) && (`date +%s` < $soft_end))
  @ to = $from + $step - 1
  if ($to > $morf) then
    set to=$morf
  endif

  # Wells's method
  set c=$c_min
  set in_file=~/$STEPFILE$c_min
  set out_file=$STEPFILE$c_min.$from-$to
  $EXE 9 $in_file $out_file $from $to
  set result=$status
  while (($result == 0) && ($c < $c_max))
    @ c++
    set in_file=$out_file
    set out_file=$STEPFILE$c.$from-$to
    $EXE 1 $in_file $out_file
    set result=$status
  end
  
  # search for sortable posets
  if ($result == 0) then
    set in_file=$STEPFILE$c.$from-$to
    set out_file=$SORTFILE$c.$from-$to
    $EXE 3 $in_file $out_file
    set result=$status
    while (($result == 0) && ($c > $c_min))
      @ c--
      set sort_file=$out_file
      set in_file=$STEPFILE$c.$from-$to
      set out_file=$SORTFILE$c.$from-$to
      $EXE 4 $in_file $out_file $sort_file
      set result=$status
    end
    if ($result == 0) then # no error and the last file contains posets
      mv -f $SORTFILE*.$from-$to ~/
    endif
  endif

  rm -f *.$from-$to

  @ from = $from + $step
  date
end

cd
rm -f $WRKDIR*
rmdir $WRKDIR
