#!/bin/csh
#PBS -N SMF
#PBS -l nodes=1:ppn=1,walltime=336:00:00,mem=1900mb,vmem=1900mb
#PBS -j oe
#PBS -k oe

if ($?m == 0) then
  set m=$1
endif
if ($?n == 0) then
  set n=$2
endif
if ($?c_min == 0) then
  set c_min=$3
endif
if ($?c_max == 0) then
  set c_max=$4
endif

set WRKDIR=/tmp1/user/F${n}_${m}/
set EXE=./proof${n}_${m}
set STEPFILE=${n}_${m}mf
set SORTFILE=${n}_${m}mb

mkdir -p $WRKDIR
cp -f $EXE $WRKDIR
set OLD_DIR=`pwd`
cd $WRKDIR

df $WRKDIR
$EXE
echo m=$m n=$n c_min=$c_min c_max=$c_max
echo
# forward steps
date
set c=$c_min
set in_file=${STEPFILE}${c}
@ c++
set sort_file=${SORTFILE}${c}
set out_file=${STEPFILE}c${c}
cp -f $OLD_DIR/$in_file $OLD_DIR/$sort_file .
#cp -f $OLD_DIR/$in_file.gz $OLD_DIR/$sort_file .
#gzip -d $in_file.gz
$EXE 4 $in_file $out_file $sort_file 1
set result=$status
while (($result == 0) && ($c < $c_max))
  @ c++
  set in_file=$out_file
  set out_file=${STEPFILE}c${c}
  $EXE 1 $in_file $out_file
  set result=$status
end
date

# backward steps
if ($result == 0) then
  # no error and at least one poset in the last file
  set in_file=${STEPFILE}c${c}
  set out_file=${SORTFILE}c${c}
  $EXE 3 $in_file $out_file
  set result=$status
  while (($result == 0) && ($c > $c_min + 1))
    @ c--
    set sort_file=$out_file
    set in_file=${STEPFILE}c${c}
    set out_file=${SORTFILE}c${c}
    $EXE 4 $in_file $out_file $sort_file
    set result=$status
  end
  @ c = $c_min + 1
  set sort_file=${SORTFILE}${c}
  if ($result == 0) then
    $EXE 10 $out_file $sort_file
  endif
  set out_file=${SORTFILE}${c_min}
  $EXE 4 ${STEPFILE}${c_min} $out_file $sort_file 2
  cp -f $out_file $OLD_DIR/
  date
endif

cd $OLD_DIR
rm -r $WRKDIR
