#!/bin/csh
#PBS -N SMG
#PBS -l nodes=1:ppn=1,walltime=336:00:00,mem=1900mb,vmem=1900mb
#PBS -j oe
#PBS -k oe

if ($?m == 0) then
  set m=$1
endif
if ($?n == 0) then
  set n=$2
endif
if ($?c_min == 0) then
  set c_min=$3
endif
if ($?c_max == 0) then
  set c_max=$4
endif


set WRKDIR=/tmp1/user/G${n}_${m}/
set EXE=./proof${n}_${m}
set STEPFILE=${n}_${m}mf
set SORTFILE=${n}_${m}mb

mkdir -p $WRKDIR
cp -f $EXE $WRKDIR
set OLD_DIR=`pwd`
cd $WRKDIR

df $WRKDIR
$EXE
echo m=$m n=$n c_min=$c_min c_max=$c_max
set comp=$c_min
while ($comp <= $c_max)
  echo
  echo testing $comp comparisons
  echo
  # forward steps - Wells's method
  date
  set c=0
  set out_file=$STEPFILE$c
  $EXE 2 $out_file $comp
  set result=$status
  if ($result == 0) then
    while (($result == 0) && ($c < $comp))
      @ c++
      set in_file=$out_file
      set out_file=$STEPFILE$c
      $EXE 1 $in_file $out_file
      set result=$status
      gzip -9 $in_file
    end
    date
    # backward steps - search for sortable posets
    if ($result == 0) then
      set in_file=$out_file
      set out_file=$SORTFILE$c
      $EXE 3 $in_file $out_file
      set result=$status
      rm -f $in_file
      while (($result == 0) && ($c > 0))
        @ c--
        set sort_file=$out_file
        set in_file=$STEPFILE$c
        set out_file=$SORTFILE$c
        gzip -d ${in_file}.gz
        $EXE 4 $in_file $out_file $sort_file
        set result=$status
        #rm -f $in_file $sort_file
        rm -f $in_file
      end
      #if ($result == 0) then
      #  mv -f $SORTFILE* $OLD_DIR/
      #endif
      date
    endif
  endif
  if ($result <= 1) then
    rm -f $STEPFILE* $SORTFILE*
  else
    exit
  endif
  @ comp++
end

cd $OLD_DIR
rm -r $WRKDIR
