#!/bin/csh
#PBS -N SN
#PBS -l nodes=1:ppn=2,cput=336:00:00,mem=1900mb
#PBS -j oe
#PBS -k oe
# Above settings are only example.
# Minimum-Comparisons Sorting Experiments for n = 11, 12, 13, 14, 22.
# N have to be defined.
if ($?n == 0) then
  set n=$1
endif

if ($n == 11) then
  set c_n=26
  set EXE=./proof11
else if ($n == 12) then
  set c_n=29
  set EXE=./proof12
else if ($n == 13) then
  set c_n=33
  set EXE=./proof13
else if ($n == 14) then
  set c_n=37
  set EXE=./proof14
else if ($n == 22) then
  set c_n=70
  set EXE=./proof22
else
  echo "wrong number of elements"
  exit 0
endif

set WRKDIR=/tmp1/user/S$n/
set STEPFILE=${n}step
set SORTFILE=${n}sort
mkdir -p $WRKDIR
#rm -rf $WRKDIR*
cp -f $EXE $WRKDIR
set OLD_DIR=`pwd`
cd $WRKDIR

# forward steps - Wells's method
date
set c=1
set out_file=$STEPFILE$c
$EXE 0 $out_file $c_n
set result=$status
while (($result == 0) && ($c < $c_n))
  @ c++
  set in_file=$out_file
  set out_file=$STEPFILE$c
  $EXE 1 $in_file $out_file
  set result=$status
end
date

# backward steps - search for sortable posets
if ($result == 0) then
  # no error and at least one poset in the last file
  set in_file=$STEPFILE$c
  set out_file=$SORTFILE$c
  $EXE 3 $in_file $out_file
  set result=$status
  while (($result == 0) && ($c > 1))
    @ c--
    set sort_file=$out_file
    set in_file=$STEPFILE$c
    set out_file=$SORTFILE$c
    $EXE 4 $in_file $out_file $sort_file
    set result=$status
  end
  date
endif

cd $OLD_DIR
rm -r $WRKDIR
